% Multi-Class Hierarchical Mixture of Experts Model
%
% Throughout, n = number of samples, d = dimensionality of samples,
% k = number of classes.  In the gating network, b = branching factor.
%
% The HME data structure is a tree.  Internal nodes and leaf nodes
% are of different types.  
%
% The leaf node (expert) fields are:
%
%	hme.leaf	Set to 1
%	hme.param	dxk matrix of logistic model coefficients
%
% The internal node (gating) fields are:
%
%	hme.leaf	Set to 0
%	hme.param	dxb matrix of logistic model coefficients
%	hme.children	b-element cell array of children
%
% See also hmeCreate, hmeFit, hmeEval, hmeVis.
%
% David Martin <dmartin@eecs.berkeley.edu> 
% Charless Fowlkes <fowlkes@eecs.berkeley.edu>
% May 7, 2002

% Copyright (C) 2002 David R. Martin <dmartin@eecs.berkeley.edu>
% Copyright (C) 2002 Charless C. Fowlkes <fowlkes@eecs.berkeley.edu>
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of the
% License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
% 02111-1307, USA, or see http://www.gnu.org/copyleft/gpl.html.


