clear all; clc; close all;
load ../netlab3.3/temp.mat

fh1 = figure;
plot(data(label==1,1), data(label==1,2), 'bo');
hold on
axis([-4 5 -4 5])
set(gca, 'box', 'on')
plot(data(label==2,1), data(label==2,2), 'rx')
title('Data')

issoftmax = 1;

if issoftmax
    targets = [targets targets];
    targets(:,2)=1-targets(:,2);
    % two class outputs
    net = glm(input_dim, 2, 'softmax');
else
    net = glm(input_dim, 1, 'logistic');
end

% do not randomize intial condition
net = glmunpak(net, [0 0 0 0 0 0] );

options = foptions;
options(1) = 1; % display
options(14) = 100;

net = glmtrain_weighted(net, options, data, targets, weight, 1);

z = glmfwd(net, data);
z(z>=0.5)=1;
z(z<0.5)=0;

error = sum((z(:,1)~=targets(:,1)).*weight);

x = -4.0:0.2:5.0;
y = -4.0:0.2:5.0;
[X, Y] = meshgrid(x,y);
X = X(:);
Y = Y(:);
grid = [X Y];
Z = glmfwd(net, grid);
if issoftmax
    tZ = reshape(Z(:,2), length(x), length(y));
else
    tZ = reshape(Z(:), length(x), length(y));
end
v = [0.1 0.5 0.9];
[c, h] = contour(x, y, tZ, v);
title('Generalized Linear Model')
set(h, 'linewidth', 3)
clabel(c, h);

tmp = [net.w1; net.b1]
net.w1 / sum(net.w1)

