function LL = CA_weighted_cond_LL(CA_model, ...
    train_X, train_C, post_pC, condtype)
% NEWONE

% minimum p(C|X)
min_pc_x = 0.001;

assert(strcmpi(condtype,'pC_X')==1);

num = size(train_X, 1);

nclass = CA_model.nclass;
objmix = CA_model.objmix;

probC = CA_model.probC;

pX_C = zeros(num, nclass);

%%%%%% for both CA_chain or CA_full, first obtain p(C|X)%%%%%%%%%
for i = 1:nclass
    pX_C(:,i) = gmmprob(objmix{i}, train_X);
end
pCX = pX_C .* (ones(num,1)*probC);

for k = 1:num
    this_pC_X = pCX(k,:) / sum(pCX(k,:));
    this_pC_X = this_pC_X + min_pc_x;
    pC_X(k,:) = this_pC_X / sum(this_pC_X);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

matLL = log(pC_X).*post_pC;

LL = sum(matLL(:));


