function CLL = DP_fun_CLL_subset(pX0, alldata)
% CLL = DP_fun_CLL_subset(pX0, alldata)
% DP: pX0 is the partial X for optimize

probeps = 1e-40;

X = alldata.fullX;
X(1,alldata.index) = pX0;

if any(X<alldata.LB)
    X = max(X,alldata.LB);
end

if any(X>alldata.UB)
    X = min(X, alldata.UB);
end

DPgmm = DP_put_para(alldata.DPgmm, X);

posprob = DP_prob(DPgmm, alldata.X);

posind = (alldata.A == 1);
negind = (alldata.A == 0);

negprob = 1 - posprob;

posprob(negind) = 0;
negprob(posind) = 0;

prob = posprob+negprob;

if any(prob<probeps)
    prob = max(prob, probeps);
end

CLL = - sum(log(prob));