function DPgmm = DP_put_para(DPgmm, X)
% DPgmm = DP_put_para(DPgmm, X)
% DP: put the new parameters to the DPgmm structure

paracount = length(X);

ratio = DPgmm.ratio;
posmix = DPgmm.posmix;
negmix = DPgmm.negmix;

dim = X(1);
assert(dim == posmix.nin);

nmix1 = X(2);
nmix2 = X(3);

assert(nmix1 == posmix.ncentres);
assert(nmix2 == negmix.ncentres);

num = 4;
ratio = X(num);

len = nmix1 - 1;
ind = num+1:num+len;
posmix.priors(1,1:len) = X(1,ind);
posmix.priors(1,len+1) = 1-sum(X(1,ind));
num = num + len;

len = nmix2 - 1;
ind = num+1:num+len;
negmix.priors(1,1:len) = X(1,ind);
negmix.priors(1,len+1) = 1-sum(X(1,ind));
num = num + len;

for i=1:nmix1
    ind = num+1:num+dim;
    posmix.centres(i,:) = X(1,ind);
    num = num+dim;
    
    ind = num+1:num+dim;
    posmix.covars(i,:) = X(1,ind);
    num = num+dim;
end

for i=1:nmix2
    ind = num+1:num+dim;
    negmix.centres(i,:) = X(1,ind);
    num = num+dim;
    
    ind = num+1:num+dim;
    negmix.covars(i,:) = X(1,ind);
    num = num+dim;
end
assert(num == paracount);

DPgmm.posmix = posmix;
DPgmm.negmix = negmix;
DPgmm.ratio = ratio;
