function [trainErr,testErr,index] = all_plot_errorbar(chain_trainErr, chain_testErr, str, individual)

trainErr = mean(chain_trainErr,1);
trainStd = std(chain_trainErr,1);

testErr = mean(chain_testErr,1);
testStd = std(chain_testErr,1);

s = size(trainErr);
s(1) = [];
trainErr = reshape(trainErr,s);
trainStd = reshape(trainStd,s);
testErr = reshape(testErr,s);
testStd = reshape(testStd,s);

subtitle={'tra','mov','sup','avg','grp','cat'};
if individual == 1
    figure
    for k = 1:6
        subplot(2,3,k);
        errorbar(trainErr(:,k),trainStd(:,k));
        title(subtitle{k});
        if k < 5
            axis([0 21 0 0.21]);
        else
            axis([0 21 0 0.31]);
        end
    end
    suptitle(['train error: ' str]);
    
    figure
    for k = 1:6
        subplot(2,3,k);
        errorbar(testErr(:,k),testStd(:,k));
        title(subtitle{k});
        if k < 5
            axis([0 21 0 0.21]);
        else
            axis([0 21 0 0.31]);
        end
    end
    suptitle(['test error: ' str]);
end

figure
set(gcf,'Position',100+[0 0 800 600]);
for k = 1:6
    subplot(2,3,k);
    hold on;
    errorbar(trainErr(:,k),trainStd(:,k));
    errorbar(testErr(:,k),testStd(:,k),'r');
    title(subtitle{k});    
    if k < 5
        axis([0 21 0 0.21]);
    else
        axis([0 21 0 0.31]);
    end
end
suptitle([str 'error   train(green) test(red)']);
cmdstr = ['print -dbmp16m ' str '.bmp'];
eval(cmdstr);

avgerr = chain_trainErr(:,:,4);
grperr = chain_trainErr(:,:,5);
numexp = size(avgerr,1);
trainErr = zeros(numexp,6);
testErr = trainErr;
for i=1:numexp
    % CHANGE HERE
    [tmp,ind] = min(avgerr(i,:));
    index(i)=ind;
    % [tmp,ind] = min(grperr(i,:));
    trainErr(i,:) = reshape(chain_trainErr(i,ind,:),1,6);
    testErr(i,:) = reshape(chain_testErr(i,ind,:),1,6);
end

[mean(trainErr(1:5,:)); std(trainErr(1:5,:))]

[mean(testErr(1:5,:)); std(testErr(1:5,:))]

trainErr(1:5,:)

testErr(1:5,:)