clear all; close all; clc;
total_p = 5;
NUMMIX = 2

batch_trainerr = zeros(total_p,5);
batch_testerr = zeros(total_p, 5);

all_predA = cell(1,total_p);

for p=1:total_p
    load train_data

    DPgmm_array = cell(1,3);
    DP_iter = 30;
    nummixpos = NUMMIX;
    nummixneg = NUMMIX;

    trainerr_array = zeros(3,DP_iter);
    testerr_array = trainerr_array;

    for aff = 1:3
        [DP, trainerr, testerr]  = DP_learn_GMM( ...
            train_X, train_A, test_X, test_A, aff, [], ...
            nummixpos, nummixneg, 'discriminative', DP_iter);
        DPgmm_array{aff} = DP;
        trainerr_array(aff,:) = trainerr;
        testerr_array(aff,:) = testerr;
        [min_trainerr(aff), index(aff)] = min(trainerr);
        min_testerr(aff) = testerr_array(aff, index(aff));
    end

    batch_trainerr(p,1:3) = min_trainerr;
    batch_testerr(p,1:3) = min_testerr;
    trainmask = sum(train_A>-1);
    batch_trainerr(p,4) = sum(trainmask.*min_trainerr)/sum(trainmask);
    batch_testerr(p,4) = mean(min_testerr);
    
    for aff = 1:3
        DP = DPgmm_array{aff}{index(aff)};
        prob = DP_prob(DP, test_X);
        prob=(prob>=0.5);
        predict_A(:,aff) = prob;
    end

    all_predA{p} = predict_A;
%     for aff = 1:3
%         figure(aff); hold on;
%         plot(trainerr_array(aff,:));
%         plot(testerr_array(aff,:),'r-');
%     end

    grp_A = any(predict_A'~=test_A');
    % group error
    disp('group error');
    sum(grp_A) / length(grp_A)
    batch_testerr(p,5) = sum(grp_A) / length(grp_A);

    for aff = 1:3
        pA = predict_A(:,aff);
        tA = test_A(:,aff);
        posind = (tA==1);
        negind = (tA==0);
        % false neg error and false pos
        e1(aff) = sum(pA(posind)~=tA(posind))/sum(posind);
        e2(aff) = sum(pA(negind)~=tA(negind))/sum(negind);
    end
    % false neg error and false pos
    [e1; e2]

    % individual error for each afford
    disp('individual error');
    err = (predict_A~=test_A);
    sum(err)/size(test_A,1)

    % average error
    disp('avg error');
    sum(err(:))/length(test_A(:))

    disp('positive train data ratio');
    sum(train_A==1)./sum(train_A>-1)
    
   
    
end

[mean(batch_trainerr); std(batch_trainerr)]
[mean(batch_testerr); std(batch_testerr)]
batch_trainerr
batch_testerr
save DP2
