tic

switch modeltype
    case 'CA_chain'
        suptitlestr = 'CA-Chain-'
    case 'CA_full'
        suptitlestr = 'CA-Full-';
    otherwise
        
end

       
for p=1:total_p
    figure(100+p);

    subplot(4,3,1);
    plot(trainLL(p,:)); title('train LL');
    subplot(4,3,2);
    plot(trainCLL(p,:)); title('train CLL');
    subplot(4,3,3);
    plot(trainCLL_grp(p,:),'r-'); title('train CLL grp');
    subplot(4,3,4);
    plot(testLL(p,:),'r-'); title('test LL');
    subplot(4,3,5);
    plot(testCLL(p,:),'r-'); title('test CLL');
    subplot(4,3,6)
    plot(testCLL_grp(p,:),'r-'); title('test CLL grp');

    titlecell={'trav','move','supp','avg','group','cat'};
    for k = 1:6
        subplot(4,3,k+6);
        hold on;
        plot(chain_trainErr(p,:,k),'g-');
        plot(chain_testErr(p,:,k),'r-');
        title(titlecell{k});
    end
    suptitle(suptitlestr);
    
    str = ['print -dbmp16m ' suptitlestr num2str(100+p) '.bmp'];
    eval(str);
end

if total_p > 1
    figure(1);
    subplot(3,2,1);
    a=trainLL;
    errorbar(1:20,mean(a),std(a));
    x=axis; x(2)=21;
    axis(x);
    title('train LL');

    subplot(3,2,3);
    a=trainCLL;
    errorbar(1:20,mean(a),std(a));
    x=axis; x(2)=21;
    axis(x);
    title('train CLL');

    subplot(3,2,5);
    a=trainCLL_grp;
    errorbar(1:20,mean(a),std(a));
    x=axis; x(2)=21;
    axis(x);
    title('train CLL grp');

    subplot(3,2,2);
    a=testLL;
    errorbar(1:20,mean(a),std(a));
    x=axis; x(2)=21;
    axis(x);
    title('test LL');

    subplot(3,2,4);
    a=testCLL;
    errorbar(1:20,mean(a),std(a));
    x=axis; x(2)=21;
    axis(x);
    title('test CLL');

    subplot(3,2,6);
    a=testCLL_grp;
    errorbar(1:20,mean(a),std(a));
    x=axis; x(2)=21;
    axis(x);
    title('test CLL grp');

    suptitle(suptitlestr);
    str = ['print -dbmp16m ' suptitlestr 'LL.bmp'];
    eval(str);

    % normalized case
    figure(2);
    subplot(3,2,1);
    a=trainLL; a=(a)./(a(:,1)*ones(1,20)).*sign(a);
    errorbar(1:20,mean(a),std(a));
    x=axis; x(2)=21;
    axis(x);
    title('train LL');

    subplot(3,2,3);
    a=trainCLL; a=(a)./(a(:,1)*ones(1,20)).*sign(a);
    errorbar(1:20,mean(a),std(a));
    x=axis; x(2)=21;
    axis(x);
    title('train CLL');

    subplot(3,2,5);
    a=trainCLL_grp; a=(a)./(a(:,1)*ones(1,20)).*sign(a);
    errorbar(1:20,mean(a),std(a));
    x=axis; x(2)=21;
    axis(x);
    title('train CLL grp');

    subplot(3,2,2);
    a=testLL; a=(a)./(a(:,1)*ones(1,20)).*sign(a);
    errorbar(1:20,mean(a),std(a));
    x=axis; x(2)=21;
    axis(x);
    title('test LL');

    subplot(3,2,4);
    a=testCLL; a=(a)./(a(:,1)*ones(1,20)).*sign(a);
    errorbar(1:20,mean(a),std(a));
    x=axis; x(2)=21;
    axis(x);
    title('test CLL');

    subplot(3,2,6);
    a=testCLL_grp; a=(a)./(a(:,1)*ones(1,20)).*sign(a);
    errorbar(1:20,mean(a),std(a));
    x=axis; x(2)=21;
    axis(x);
    title('test CLL grp');

    suptitle(suptitlestr);
    str = ['print -dbmp16m ' suptitlestr 'LL_norm.bmp'];
    eval(str);
end

toc