function [unknown_C, unknown_A] = check_train_AC(train_C, train_A, train_X, nclass, nafford)
% CA: check if training data range is correct
% [unknown_C, unknown_A] = check_train_AC(train_C, train_A, train_X, ...
%      nclass, nafford)
% unkown is labeled as -1 for C or A, otherwise
% C: from 1 to nclass

num = length(train_C);
dim = size(train_X,2);

assert(size(train_A,1)==num);
assert(size(train_X,1)==num);
assert(size(train_A,2)==nafford);
assert(max(train_C)==nclass);

%%%% sanity check of train_C, train_A %%%%
for i = 1:nclass
    c_count(i)=sum(train_C==i);
end
c_count(nclass+1)=sum(train_C==-1);
assert(sum(c_count)==num);

for i = 1:nafford
    for j = -1:1
        a_count(j+2)=sum(train_A(:,i)==j);
    end
    assert(sum(a_count)==num);
    unknown_A(i) = a_count(1);
end

unknown_C = c_count(nclass+1);