function ret = confusion(d,cap1,cap2)
% CA: show the confusion matrix of 7 objects, with captions
% ret = confusion(d,cap1,cap2)
maxthresh=1.1;
minthresh=0.05;

nc=size(d,1);
c=zeros(nc);
names={'box','cabinet','chair','door','shelf','table','ground'};

names2 = {'C = 1','C = 2','C = 3','C = 4','C = 5','C = 6','C = 7'};

figure1 = figure('Color',[1 1 1]);
axes1 = axes('Layer','top','Position',[0 0 1 1],'YDir','reverse','Parent',figure1);
extra = 1.2;
enc = nc+extra; % effective number of cell = number of class + 2
axis image
axis off
set(gcf,'Position',[100 100 480 480]);
for i=1:nc
    for j=1:nc
        gray=d(i,j);
%         if gray<0.1
%             rectangle('Position',[(j+extra-1)/enc (i-1)/enc 1/enc 1/enc],'FaceColor',[gray gray gray]*3)
%         else
            rectangle('Position',[(j+extra-1)/enc (i-1)/enc 1/enc 1/enc],'FaceColor',[gray gray gray])
%         end

        if d(i,j)<maxthresh && d(i,j)>minthresh
            if gray > 0.5
                textgray = [0 0 0];
            else
                textgray = [1 1 1];
            end
            
            text(j/enc+extra/enc-0.5/enc,i/enc-0.5/enc,...
                num2str(d(i,j),'%.2f'),...
                'HorizontalAlignment','center',...
                'Color',textgray,...
                'FontSize',12);
        end
    end
end

for i=1:nc
    text(extra/enc-0.1/enc,i/enc-0.5/enc,names{i},...
        'HorizontalAlignment','right',...
        'FontSize',12,'FontWeight','bold');
    text(extra/enc-0.5/enc+i/enc,nc/enc+0.1/enc,names2{i},...
        'HorizontalAlignment','left',...
        'Rotation',270,...
        'FontSize',12,'FontWeight','bold');
end
% text(0.01,0.97,cap,'FontSize',10,'FontWeight','bold','Color','b','EdgeColor','b')
text(0.01,0.945,cap1,'FontSize',10,'FontWeight','bold','Color','b')
text(0.01,0.98,cap2,'FontSize',10,'FontWeight','bold','Color','b')