function CA_model = init_CA_model(type)
% CA: initialize the CA model, with each field being empty

% only allow two versions
valid = strcmpi(type,'CA_chain') | strcmpi(type,'CA_full');
assert(valid);

CA_model = struct('objmix',[], 'probC', [], 'probA_C', [], ...
    'nclass', [], 'nmixture', [], ...
    'nafford', [], 'ndim', [], ...
    'type', type, ...
    'pxa_ll', [], ... % TRUE joint data likelihood (LL)
    'pa_x_ll', [], ... % TRUE conditional data likelihood (CLL)
    'pa_x_ll_sep', [], ... % CLL when separting each A (CLL_sep)
    'gmm_ll', [], ... % from EM on learning mixture
    'pxca_ll', [], ... % !!this is errorsome, normally no use
    'pca_ll', [], ... % !!normally not used
    'err_aff_sep', [], ... % separate affordance error
    'affglm', [] ... % GLM models for CA_full model
    );
