function catdef = load_define(fname, maxnum)
% CA: load all the file data to catdef structure, unorganized
% but if one file has more than maxnum data, sample to get maxnum data

data = csvread(fname,1,1);
cat = data(:,1);
aff = data(:,2:end);

numfile = length(cat);
numobj = max(cat);
numaff = size(aff,2);

affname=cell(1,numaff);
filename=cell(1,numfile);

fid=fopen(fname);
tline=fgetl(fid);
% disp(tline);
pos=findstr(tline,',');
pos(end+1)=length(tline)+1;
for i=1:numaff
   affname{i}=tline(pos(i+1)+1:pos(i+2)-1);
end

i=1;
while 1
    tline=fgetl(fid);
    if ~ischar(tline), break, end
    
%     disp(tline);
    pos=findstr(tline,',');
    filename{i}=tline(1:pos(1)-1);
    i=i+1;
end
fclose(fid);

catdef=struct('numobj',[],'numaff',[], ...
    'numfile',[],'filename',[], 'count',[], 'filedata',[], ...
    'affname',[], ...
    'category',[],'affordance',[]);

catdef.numobj = numobj;
catdef.numaff = numaff;
catdef.numfile = numfile;
catdef.filename = filename;
catdef.affname = affname;
catdef.category = cat;
catdef.affordance = aff;
catdef.count = zeros(numfile,1);
catdef.filedata = cell(1,numfile);

for i = 1:numfile
    fname = ['./train/' catdef.filename{i}];
    disp(fname);
    [label, data]=read_sparse(fname);
    data = full(data);

    num = length(label);
    if num > maxnum
        index = 1:num;
        sample_index=rand_sample(index,maxnum,0);
        data = data(sample_index,:);
        label = label(sample_index,:);
    end
    
    catdef.count(i) = length(label);
    catdef.filedata{i} = data;
end