function [train_A, train_C] = modify_train_data(train_A, train_C, type, opt1, opt2)
%CA: modify the training data to hide some variables
%[train_A, train_C] = modify_train_data(train_A, train_C, ...
%    type, opt1, opt2)
% type: fixed/random
% opt1: subnum for 'fixed' option
% opt2: numknownaffordance for 'fixed' option
switch type
    case 'fixed'
        subnum = opt1;
        nknown = opt2;
        naff = size(train_A,2);

        numtotal = length(train_C);
        nclass = max(train_C);
        numtrain = numtotal/nclass;
        
        assert(mod(numtotal, nclass) == 0);
        assert(subnum <= numtrain);
        assert(nknown<=naff);

        if subnum < numtrain
            unkn = numtrain - subnum;
            for i=1:nclass
                ind = find(train_C == i);
                sample_ind = rand_sample(ind, unkn, 0);
                train_C(sample_ind) = -1;
            end
        end

        unkn = naff - nknown;
        if nknown < naff
            for i=1:numtotal
                ind = rand_sample(1:naff, unkn, 0);
                train_A(i,ind) = -1;
            end
        end
        
    case 'random'
        missratio_C = opt1;
        missratio_A = opt2;

        mask_C = rand(size(train_C));
        mask_A = rand(size(train_A));

        train_A(mask_A < missratio_A) = -1;
        train_C(mask_C < missratio_C) = -1;
end