% % CA-chain: Calculate error and conditional probabilities

% these are the JOINT P(A|X) on partial train and complete test set
[CLLjoint_train(j), Err_group_train(j)] = CA_cond_LL(CA_chain, 'CA_chain', ...
    train_X, train_C, train_A, ...
    'pA_X_group_err');
[CLLjoint_test(j), Err_group_test(j)] = CA_cond_LL(CA_chain, 'CA_chain', ...
    test_X, test_C, test_A(:,1:nafford), ...
    'pA_X_group_err');

% these are the SEPARATE ERROR on partial train and complete test set
% 1:nafford -> error for each affordance
% nafford+1 -> total error
% nafford+2 -> group error (but not all affordance are observed)
[CLLsep_train(j), Err_train(j,1:nafford+2)] = CA_cond_LL(CA_chain, 'CA_chain', ...
    train_X, train_C, train_A, ...
    'pA_X_sep');
[CLLsep_test(j), Err_test(j,1:nafford+2)] = CA_cond_LL(CA_chain, 'CA_chain', ...
    test_X, test_C, test_A(:,1:nafford), ...
    'pA_X_sep');

% these are the REAL JOINT ERROR on complete train and test set
% nafford+4 -> real joint error
% [tmp, Err_group_train(j)] = CA_cond_LL(CA_chain, 'CA_chain', ...
%     train_X, train_C, train_A_full(:,1:nafford), ...
%     'pA_X_group_err');
% [tmp, Err_group_test(j)] = CA_cond_LL(CA_chain, 'CA_chain', ...
%     test_X, test_C, test_A(:,1:nafford), ...
%     'pA_X_group_err');

CLLjoint = [CLLjoint_train;  CLLjoint_test]
CLLsep = [CLLsep_train; CLLsep_test]
Err_train
Err_test

% Err_group_train is 1.0, because of '-1' values
Err_group_test