function [err, post_pC] = get_CA_err(CA_model, ...
    train_X, train_C, train_A, min_post_c)
%CA: claculate error on testing data for chain/full model
% handles missing values too

X = train_X;
C = - ones(size(train_C));
A = - ones(size(train_A));

[post_pC, post_pA, post_pC_X] = CA_posterior(CA_model, CA_model.type, ...
    X, C, A, min_post_c);
num = length(train_C);
[pcmax, cmax] = max(post_pC');
ind1 = (cmax' == train_C);
ind2 = (train_C > -1);
ind = ind1 & ind2;
err_c = 1 - sum(ind) / sum(ind2);

amax = (post_pA>=0.5);
mask = (train_A > -1);
acorr = (amax == train_A) & mask;
err_a = 1 - sum(acorr) ./ sum(mask);
err_avg = 1 - sum(acorr(:)) ./ sum(mask(:));
err_grp = any( ((amax~=train_A) & mask)' );
err_grp = sum(err_grp) / length(err_grp);
err = [err_a err_avg err_grp err_c];

