function [X, A, B, Aeq, Beq, LB, UB] = get_CA_para(CA_chain, train_X)
% CA: get the CA model parameters from row vector X

% now only work for 2 mixtures per class
min_pa_c = 0.05;

minX = min(train_X);
maxX = max(train_X);

paracount = count_CA_para(CA_chain);

objmix = CA_chain.objmix;

nclass = CA_chain.nclass;
nmixture = CA_chain.nmixture;
nafford = CA_chain.nafford;
dim = CA_chain.ndim;

X = zeros(1,paracount);
LB = X;
UB = X;
A = X;
Aeq = [];
Beq = [];

X(1:nclass-1) = CA_chain.probC(1:nclass-1);
count = nclass-1;

% constraints of category priors
B=[0.9];
A(1:nclass-1) = ones(1,nclass-1);
LB(1:nclass-1) = ones(1,nclass-1) * 0.1;
UB(1:nclass-1) = ones(1,nclass-1) * 0.2;


tmp = nclass*nafford;
pA_C = reshape(CA_chain.probA_C,1,tmp);
X(count+1:count+tmp) = pA_C;
LB(count+1:count+tmp) = min_pa_c;
UB(count+1:count+tmp) = 1-min_pa_c;
count = count+tmp;

for i = 1:nclass
    % mixture coeffients
    X(count+1:count+nmixture-1) = objmix{i}.priors(1:nmixture-1);
    % this part only works for 2 mixtures
    LB(count+1:count+nmixture-1) = 0.1 * ones(1,nmixture-1);
    UB(count+1:count+nmixture-1) = 0.9 * ones(1,nmixture-1);    
    count = count+nmixture-1;
    for j = 1:nmixture
        X(count+1:count+dim) = objmix{i}.centres(j,:);
        LB(count+1:count+dim) = minX;
        UB(count+1:count+dim) = maxX;
        count = count+dim;
        X(count+1:count+dim) = objmix{i}.covars(j,:);
        LB(count+1:count+dim) = 1e-6 * ones(1,dim);
        UB(count+1:count+dim) = 100 * ones(1,dim);
        count = count+dim;
    end
end
