% CA: main script file to do CA_chain experiment

clc; clear all; close all;
rand('state',sum(100*clock));

disp('Deleting all *.mat files, press any key to continue...');
pause(5);
!del *.mat


%%%%%%%%%% (1) Generate Data & PCA Projection %%%%%%%%%%
script_loadproject;

projdim1 = 20; % HS histo: 288 -> projdim1
projdim2 = 10; % edge histo: 15 -> projdim2

[featuredim, projdata1, projdata2] = pca_experiment( ...
    objdata,303,288,projdim1,projdim2);


%%%%%%%%%% (2) Sample the training and testing data %%%%%%%%%%
dim1 = 10;
dim2 = 5;
dim = dim1+dim2;
numtrain = 1000; % per object class (7 obj)
numtest = 900; % per object class (7 obj)

[train_data, test_data]= generate_traintest_data( ...
    affdata, ... % contains each individual datapoint's affordance value
    projdata1, projdata2, dim1, dim2, ...
    numtrain, numtest, ...
    0.001);  % ratio to apply to projdata2.X since they >> projdata1

train_X = train_data.X;
train_C = train_data.C;
train_A = train_data.A;

test_X = test_data.X;
test_C = test_data.C;
test_A = test_data.A;

nclass = 7;
nafford = 6;

disp('Sanity check of the training data (value range)');
[unknown_C, unknown_A] = check_train_AC( ...
    train_C, train_A, train_X, nclass, nafford)

save train_data.mat train* test* n* dim
clear all;
load train_data.mat
