clear all; close all; clc;

load train_data;
load CA;

rand('state',sum(100*clock));

total_p = 20;
totalsample = 200;
total_step = 20;
eachstep = totalsample / total_step;

num = size(train_X,1);
totalindex = 1:num;

all_error = zeros(3, total_p, total_step);

CA.type = 'CA_chain';

DP_nummix = 3;
DP_iter = 20;

Chain_error = zeros(3, total_p, total_step);
Full_error = Chain_error;
DP_error = Chain_error;

for p = 1:total_p
    dispstar();disp(p);dispstar();
    totalindex = rand_sample(totalindex, totalsample, 0);
    
    for step = 1:total_step
        index = rand_sample(totalindex, eachstep*step, 0);
        
        for aff = 4:6

            part_train_A = train_A(index, aff);
            part_train_X = train_X(index, :);

            disp('chain');
            [new_CA_chain, trainerr, trainnumA, testerr, testnumA] = new_learn_affordance( ...
                CA, part_train_X, part_train_A, test_X, test_A(:,aff), 'chain');
            Chain_error(aff-3, p, step) = testerr;
            
            disp('full');
            [new_CA_chain, trainerr, trainnumA, testerr, testnumA] = new_learn_affordance( ...
                CA, part_train_X, part_train_A, test_X, test_A(:,aff), 'full');
            Full_error(aff-3, p, step) = testerr;

            numpos = sum(part_train_A==1);
            numneg = sum(part_train_A==0);
            if numpos <=2 || numneg <=2
                DP_error(aff-3, p, step) = 1;
            else
                posnummix = min(floor(numpos/2),DP_nummix);
                negnummix = min(floor(numneg/2),DP_nummix);
                [DP, trainerr, testerr]  = DP_learn_GMM( ...
                    train_X(index,:), train_A(index,:), test_X, test_A, aff, [], ...
                    posnummix, negnummix, 'discriminative', DP_iter);
                [minerr, minind] = min(trainerr);

                DP_error(aff-3, p, step) = testerr(minind);
            end
        end
    end
end

save newafford_results

% clc; close all;

xind = (1:total_step)* eachstep;
affname = {'Magnetic','Lockable','Flammable'};
titlestr = cell(1,3);
for k = 1:3
    disp('');
    figure;
    hold on;

    a = reshape(DP_error(k,:,:),total_p, total_step); 
    DPmean = mean(a);
    DPstd = std(a);
    errorbar(xind(2:end), DPmean(2:end), DPstd(2:end),'r','LineWidth',2);
    
    a = reshape(Full_error(k,:,:),total_p, total_step);
    Fullmean = mean(a);
    Fullstd = std(a);
    errorbar(xind, Fullmean, Fullstd, 'g','LineWidth',2);

    a = reshape(Chain_error(k,:,:),total_p, total_step); 
    Chainmean = mean(a);
    Chainstd = std(a);
    errorbar(xind, Chainmean, Chainstd,'LineWidth',2);
    
    axis([0 totalsample+eachstep 0 0.5]);
    xlabel('Num training data');
    ylabel('Classification error');
    titlestr{k}=['Classification error for ' affname{k} ' affordance'];
    title(titlestr{k});
end

%% the old implementation has strange patterns that
%% with more training data the variance get higher
%% this is due to a bad random number generation
% for p = 1:total_p
%     for step = 1:total_step
%         partnum = step * 10;
%         
%         for aff = 4:6
% 
%             index = rand_sample(totalindex, partnum, 0);
%             
%             part_train_A = train_A(index, aff);
%             part_train_X = train_X(index, :);
% 
%             [new_CA_chain, trainerr, trainnumA, testerr, testnumA] = new_learn_affordance( ...
%                 CA, part_train_X, part_train_A, test_X, test_A(:,aff), 'chain');
%             Chain_error(aff-3, p, step) = testerr;
%             
%             numpos = sum(part_train_A==1);
%             numneg = sum(part_train_A==0);
%             
%             
%             if numpos <=2 || numneg <=2
%                 DP_error(aff-3, p, step) = 1;
%             else
%                 posnummix = min(floor(numpos/2),DP_nummix);
%                 negnummix = min(floor(numneg/2),DP_nummix);
%                 [DP, trainerr, testerr]  = DP_learn_GMM( ...
%                     train_X(index,:), train_A(index,:), test_X, test_A, aff, [], ...
%                     posnummix, negnummix, 'discriminative', DP_iter);
%                 [minerr, minind] = min(trainerr);
% 
%                 DP_error(aff-3, p, step) = testerr(minind);
%             end
%         end
%     end
% end
