function CA_chain = put_CA_para(CA_chain, X)
% CA: put the CA model parameters to row vector X
% CA_chain = put_CA_para(CA_chain, X)

paracount = count_CA_para(CA_chain);

objmix = CA_chain.objmix;

nclass = CA_chain.nclass;
nmixture = CA_chain.nmixture;
nafford = CA_chain.nafford;
dim = CA_chain.ndim;

CA_chain.probC(1:nclass-1) = X(1:nclass-1);
CA_chain.probC(nclass) = 1 - sum(X(1:nclass-1));
count = nclass-1;

tmp = nclass*nafford;
pA_C = X(count+1:count+tmp);
CA_chain.probA_C = reshape(pA_C, nclass, nafford);
count = count+tmp;

for i = 1:nclass
    % mixture coeffients
    objmix{i}.priors(1:nmixture-1) = X(count+1:count+nmixture-1);
    objmix{i}.priors(nmixture) = 1 - sum(X(count+1:count+nmixture-1));
    count = count+nmixture-1;
    
    for j = 1:nmixture
        objmix{i}.centres(j,:) = X(count+1:count+dim);
        count = count+dim;
        objmix{i}.covars(j,:) = X(count+1:count+dim);
        count = count+dim;
    end
end

CA_chain.objmix = objmix;

assert(count==paracount);
