clear all; close all; clc;
load train_data

DPgmm_array = cell(1,3);
DP_iter = 20;
nummixpos = 3;
nummixneg = 3;

trainerr_array = zeros(3,DP_iter);
testerr_array = trainerr_array;

for aff = 1:3
    [DP, trainerr, testerr]  = DP_learn_GMM( ...
        train_X, train_A, test_X, test_A, aff, [], ...
        nummixpos, nummixneg, 'discriminative', DP_iter);
    DPgmm_array{aff} = DP;
    trainerr_array(aff,:) = trainerr;
    testerr_array(aff,:) = testerr;
    [min_trainerr(aff), index(aff)] = min(trainerr);
    min_testerr(aff) = testerr_array(aff, index(aff));
end

for aff = 1:3
    DP = DPgmm_array{aff}{index(aff)};
    prob = DP_prob(DP, test_X);
    prob=(prob>=0.5);
    predict_A(:,aff) = prob;
end

for aff = 1:3
    figure(aff); hold on;
    plot(trainerr_array(aff,:));
    plot(testerr_array(aff,:),'r-');
end

grp_A = any(predict_A'~=test_A');
% group error
sum(grp_A) / length(grp_A)

for aff = 1:3
    pA = predict_A(:,aff);
    tA = test_A(:,aff);
    posind = (tA==1);
    negind = (tA==0);
    % false neg error and false pos
    e1(aff) = sum(pA(posind)~=tA(posind))/sum(posind);
    e2(aff) = sum(pA(negind)~=tA(negind))/sum(negind);
end
[e1; e2]

% individual error
sum(predict_A~=test_A)/size(test_A,1)

sum(train_A==1)./sum(train_A>-1)
