chain_trainErr = zeros(1,20,6);
chain_testErr = chain_trainErr;

p=1;

for k = 1:CA_chain_maxiter
    CA_chain = CA_chain_array{k};
    chain_trainErr(p,k,:) = get_CA_err(CA_chain, train_X, train_C, train_A, 0.001);
    chain_testErr(p,k,:) = get_CA_err(CA_chain, test_X, test_C, test_A, 0.001);
    ll = CA_joint_LL(CA_chain, 'CA_chain', train_X, train_C, train_A, 'pXA');
    trainLL(p,k) = sum(ll);
    ll = CA_joint_LL(CA_chain, 'CA_chain', test_X, test_C, test_A, 'pXA');
    testLL(p,k) = sum(ll);
    [trainCLL(p,k), tmp] = CA_cond_LL(CA_chain, 'CA_chain', ...
        train_X, train_C, train_A, 'pA_X_sep');
    [testCLL(p,k), tmp] = CA_cond_LL(CA_chain, 'CA_chain', ...
        test_X, test_C, test_A, 'pA_X_sep');
    [trainCLL_grp(p,k), tmp] = CA_cond_LL(CA_chain, 'CA_chain', ...
        train_X, train_C, train_A, 'pA_X_group');
    [testCLL_grp(p,k), tmp] = CA_cond_LL(CA_chain, 'CA_chain', ...
        test_X, test_C, test_A, 'pA_X_group');    
end


figure(100+p);
subplot(4,3,1);
plot(trainLL(p,:)); title('train LL');
subplot(4,3,2);
plot(trainCLL(p,:)); title('train CLL');
subplot(4,3,3);
plot(trainCLL_grp(p,:),'r-'); title('train CLL grp');
subplot(4,3,4);
plot(testLL(p,:),'r-'); title('test LL');
subplot(4,3,5);
plot(testCLL(p,:),'r-'); title('test CLL');
subplot(4,3,6)
plot(testCLL_grp(p,:),'r-'); title('test CLL grp');

titlestr={'trav','move','supp','avg','group','cat'};
for k = 1:6
    subplot(4,3,k+6);
    hold on;
    plot(chain_trainErr(p,:,k),'g-');
    plot(chain_testErr(p,:,k),'r-');
    title(titlestr{k});
end
suptitle('CA Chain');


% [a, b] = CA_cond_LL(CA_chain, 'CA_chain', ...
%     train_X, train_C, train_A, 'pA_X_group')